import * as React from "react";

export interface IconProps {
  a11yTitle?: string;
  color?: string;
  size?: "small" | "medium" | "large" | "xlarge" | string;
}

export type Icon = React.ComponentType<IconProps & JSX.IntrinsicElements['svg']>;

export declare const Accessibility: Icon;
export declare const Achievement: Icon;
export declare const Action: Icon;
export declare const Actions: Icon;
export declare const Ad: Icon;
export declare const AddCircle: Icon;
export declare const Add: Icon;
export declare const Aed: Icon;
export declare const Aggregate: Icon;
export declare const AidOption: Icon;
export declare const Aid: Icon;
export declare const Alarm: Icon;
export declare const Alert: Icon;
export declare const Amazon: Icon;
export declare const Amex: Icon;
export declare const Analytics: Icon;
export declare const Anchor: Icon;
export declare const Android: Icon;
export declare const Announce: Icon;
export declare const AppleAppStore: Icon;
export declare const Apple: Icon;
export declare const Apps: Icon;
export declare const Archive: Icon;
export declare const Archlinux: Icon;
export declare const Article: Icon;
export declare const Aruba: Icon;
export declare const Ascend: Icon;
export declare const AssistListening: Icon;
export declare const Atm: Icon;
export declare const Attachment: Icon;
export declare const Attraction: Icon;
export declare const Baby: Icon;
export declare const BackTen: Icon;
export declare const BarChart: Icon;
export declare const Bar: Icon;
export declare const Basket: Icon;
export declare const Bike: Icon;
export declare const Bitcoin: Icon;
export declare const BlockQuote: Icon;
export declare const Blog: Icon;
export declare const Bluetooth: Icon;
export declare const Bold: Icon;
export declare const Book: Icon;
export declare const Bookmark: Icon;
export declare const BottomCorner: Icon;
export declare const Braille: Icon;
export declare const Briefcase: Icon;
export declare const Brush: Icon;
export declare const Bug: Icon;
export declare const Bundle: Icon;
export declare const Bus: Icon;
export declare const BusinessService: Icon;
export declare const Cafeteria: Icon;
export declare const Calculator: Icon;
export declare const Calendar: Icon;
export declare const Camera: Icon;
export declare const Capacity: Icon;
export declare const Car: Icon;
export declare const CaretDown: Icon;
export declare const CaretNext: Icon;
export declare const CaretPrevious: Icon;
export declare const CaretUp: Icon;
export declare const Cart: Icon;
export declare const CatalogOption: Icon;
export declare const Catalog: Icon;
export declare const Centos: Icon;
export declare const Channel: Icon;
export declare const ChapterAdd: Icon;
export declare const ChapterNext: Icon;
export declare const ChapterPrevious: Icon;
export declare const ChatOption: Icon;
export declare const Chat: Icon;
export declare const CheckboxSelected: Icon;
export declare const Checkbox: Icon;
export declare const Checkmark: Icon;
export declare const Chrome: Icon;
export declare const CircleInformation: Icon;
export declare const CirclePlay: Icon;
export declare const CircleQuestion: Icon;
export declare const ClearOption: Icon;
export declare const Clear: Icon;
export declare const Cli: Icon;
export declare const Clipboard: Icon;
export declare const Clock: Icon;
export declare const Clone: Icon;
export declare const Close: Icon;
export declare const ClosedCaption: Icon;
export declare const CloudComputer: Icon;
export declare const CloudDownload: Icon;
export declare const CloudSoftware: Icon;
export declare const CloudUpload: Icon;
export declare const Cloud: Icon;
export declare const Cloudlinux: Icon;
export declare const Cluster: Icon;
export declare const CoatCheck: Icon;
export declare const CodeSandbox: Icon;
export declare const Code: Icon;
export declare const Codepen: Icon;
export declare const Coffee: Icon;
export declare const Columns: Icon;
export declare const Command: Icon;
export declare const Compare: Icon;
export declare const Compass: Icon;
export declare const Compliance: Icon;
export declare const Configure: Icon;
export declare const Connect: Icon;
export declare const Connectivity: Icon;
export declare const ContactInfo: Icon;
export declare const Contact: Icon;
export declare const Contract: Icon;
export declare const Copy: Icon;
export declare const CreativeCommons: Icon;
export declare const CreditCard: Icon;
export declare const Css3: Icon;
export declare const Cube: Icon;
export declare const Cubes: Icon;
export declare const Currency: Icon;
export declare const Cursor: Icon;
export declare const Cut: Icon;
export declare const Cycle: Icon;
export declare const Dashboard: Icon;
export declare const Database: Icon;
export declare const Debian: Icon;
export declare const Deliver: Icon;
export declare const Deploy: Icon;
export declare const Descend: Icon;
export declare const Desktop: Icon;
export declare const Detach: Icon;
export declare const Device: Icon;
export declare const Diamond: Icon;
export declare const Directions: Icon;
export declare const Disc: Icon;
export declare const Dislike: Icon;
export declare const Docker: Icon;
export declare const DocumentCloud: Icon;
export declare const DocumentConfig: Icon;
export declare const DocumentCsv: Icon;
export declare const DocumentDownload: Icon;
export declare const DocumentExcel: Icon;
export declare const DocumentImage: Icon;
export declare const DocumentLocked: Icon;
export declare const DocumentMissing: Icon;
export declare const DocumentNotes: Icon;
export declare const DocumentOutlook: Icon;
export declare const DocumentPdf: Icon;
export declare const DocumentPerformance: Icon;
export declare const DocumentPpt: Icon;
export declare const DocumentRtf: Icon;
export declare const DocumentSound: Icon;
export declare const DocumentStore: Icon;
export declare const DocumentTest: Icon;
export declare const DocumentText: Icon;
export declare const DocumentThreat: Icon;
export declare const DocumentTime: Icon;
export declare const DocumentTransfer: Icon;
export declare const DocumentTxt: Icon;
export declare const DocumentUpdate: Icon;
export declare const DocumentUpload: Icon;
export declare const DocumentUser: Icon;
export declare const DocumentVerified: Icon;
export declare const DocumentVideo: Icon;
export declare const DocumentWindows: Icon;
export declare const DocumentWord: Icon;
export declare const DocumentZip: Icon;
export declare const Document: Icon;
export declare const Domain: Icon;
export declare const Dos: Icon;
export declare const Down: Icon;
export declare const Download: Icon;
export declare const Drag: Icon;
export declare const Drawer: Icon;
export declare const DriveCage: Icon;
export declare const Dropbox: Icon;
export declare const Duplicate: Icon;
export declare const Dxc: Icon;
export declare const Edge: Icon;
export declare const Edit: Icon;
export declare const Eject: Icon;
export declare const Elevator: Icon;
export declare const Emergency: Icon;
export declare const Emoji: Icon;
export declare const EmptyCircle: Icon;
export declare const Erase: Icon;
export declare const Escalator: Icon;
export declare const Expand: Icon;
export declare const FacebookOption: Icon;
export declare const Facebook: Icon;
export declare const Fan: Icon;
export declare const FastForward: Icon;
export declare const Favorite: Icon;
export declare const Fedora: Icon;
export declare const Filter: Icon;
export declare const FingerPrint: Icon;
export declare const Fireball: Icon;
export declare const Firefox: Icon;
export declare const FlagFill: Icon;
export declare const Flag: Icon;
export declare const FolderCycle: Icon;
export declare const FolderOpen: Icon;
export declare const Folder: Icon;
export declare const FormAdd: Icon;
export declare const FormAttachment: Icon;
export declare const FormCalendar: Icon;
export declare const FormCheckmark: Icon;
export declare const FormClock: Icon;
export declare const FormClose: Icon;
export declare const FormCut: Icon;
export declare const FormDown: Icon;
export declare const FormEdit: Icon;
export declare const FormFilter: Icon;
export declare const FormFolder: Icon;
export declare const FormLocation: Icon;
export declare const FormLock: Icon;
export declare const FormNextLink: Icon;
export declare const FormNext: Icon;
export declare const FormPreviousLink: Icon;
export declare const FormPrevious: Icon;
export declare const FormRefresh: Icon;
export declare const FormSchedule: Icon;
export declare const FormSearch: Icon;
export declare const FormSubtract: Icon;
export declare const FormTrash: Icon;
export declare const FormUp: Icon;
export declare const FormUpload: Icon;
export declare const FormViewHide: Icon;
export declare const FormView: Icon;
export declare const ForwardTen: Icon;
export declare const Freebsd: Icon;
export declare const Gallery: Icon;
export declare const Gamepad: Icon;
export declare const Gatsbyjs: Icon;
export declare const Gift: Icon;
export declare const Github: Icon;
export declare const Globe: Icon;
export declare const Golang: Icon;
export declare const GooglePlay: Icon;
export declare const GooglePlus: Icon;
export declare const GoogleWallet: Icon;
export declare const Google: Icon;
export declare const GraphQl: Icon;
export declare const Gremlin: Icon;
export declare const Grid: Icon;
export declare const Grommet: Icon;
export declare const Group: Icon;
export declare const Grow: Icon;
export declare const Hadoop: Icon;
export declare const Halt: Icon;
export declare const Help: Icon;
export declare const Heroku: Icon;
export declare const Hide: Icon;
export declare const History: Icon;
export declare const Home: Icon;
export declare const Horton: Icon;
export declare const HostMaintenance: Icon;
export declare const Host: Icon;
export declare const Hp: Icon;
export declare const HpeLabs: Icon;
export declare const Hpe: Icon;
export declare const Hpi: Icon;
export declare const Html5: Icon;
export declare const IceCream: Icon;
export declare const Image: Icon;
export declare const Impact: Icon;
export declare const InProgress: Icon;
export declare const Inbox: Icon;
export declare const Indicator: Icon;
export declare const Info: Icon;
export declare const Inherit: Icon;
export declare const Inspect: Icon;
export declare const Instagram: Icon;
export declare const InstallOption: Icon;
export declare const Install: Icon;
export declare const Integration: Icon;
export declare const InternetExplorer: Icon;
export declare const Italic: Icon;
export declare const Iteration: Icon;
export declare const Java: Icon;
export declare const Js: Icon;
export declare const Keyboard: Icon;
export declare const Language: Icon;
export declare const Launch: Icon;
export declare const Layer: Icon;
export declare const License: Icon;
export declare const Like: Icon;
export declare const LineChart: Icon;
export declare const LinkBottom: Icon;
export declare const LinkDown: Icon;
export declare const LinkNext: Icon;
export declare const LinkPrevious: Icon;
export declare const LinkTop: Icon;
export declare const LinkUp: Icon;
export declare const Link: Icon;
export declare const LinkedinOption: Icon;
export declare const Linkedin: Icon;
export declare const List: Icon;
export declare const Local: Icon;
export declare const LocationPin: Icon;
export declare const Location: Icon;
export declare const Lock: Icon;
export declare const Login: Icon;
export declare const Logout: Icon;
export declare const Lounge: Icon;
export declare const Magic: Icon;
export declare const MailOption: Icon;
export declare const Mail: Icon;
export declare const Mandriva: Icon;
export declare const Manual: Icon;
export declare const MapLocation: Icon;
export declare const Map: Icon;
export declare const Mastercard: Icon;
export declare const Medium: Icon;
export declare const Menu: Icon;
export declare const Microfocus: Icon;
export declare const Microphone: Icon;
export declare const Money: Icon;
export declare const Monitor: Icon;
export declare const Monospace: Icon;
export declare const MoreVertical: Icon;
export declare const More: Icon;
export declare const Multimedia: Icon;
export declare const Multiple: Icon;
export declare const Music: Icon;
export declare const Mysql: Icon;
export declare const Navigate: Icon;
export declare const Network: Icon;
export declare const NewWindow: Icon;
export declare const New: Icon;
export declare const Next: Icon;
export declare const Node: Icon;
export declare const Nodes: Icon;
export declare const Norton: Icon;
export declare const Note: Icon;
export declare const Notes: Icon;
export declare const Notification: Icon;
export declare const Npm: Icon;
export declare const ObjectGroup: Icon;
export declare const ObjectUngroup: Icon;
export declare const OfflineStorage: Icon;
export declare const Onedrive: Icon;
export declare const Opera: Icon;
export declare const Optimize: Icon;
export declare const Oracle: Icon;
export declare const OrderedList: Icon;
export declare const Organization: Icon;
export declare const Overview: Icon;
export declare const Paint: Icon;
export declare const Pan: Icon;
export declare const PauseFill: Icon;
export declare const Pause: Icon;
export declare const Paypal: Icon;
export declare const Performance: Icon;
export declare const PersonalComputer: Icon;
export declare const Phone: Icon;
export declare const PieChart: Icon;
export declare const PiedPiper: Icon;
export declare const Pin: Icon;
export declare const Pinterest: Icon;
export declare const Plan: Icon;
export declare const PlayFill: Icon;
export declare const Play: Icon;
export declare const PowerCycle: Icon;
export declare const PowerForceShutdown: Icon;
export declare const PowerReset: Icon;
export declare const PowerShutdown: Icon;
export declare const Power: Icon;
export declare const Previous: Icon;
export declare const Print: Icon;
export declare const ProductHunt: Icon;
export declare const Projects: Icon;
export declare const Qr: Icon;
export declare const RadialSelected: Icon;
export declare const Radial: Icon;
export declare const Raspberry: Icon;
export declare const Reactjs: Icon;
export declare const Reddit: Icon;
export declare const Redhat: Icon;
export declare const Redo: Icon;
export declare const Refresh: Icon;
export declare const Resources: Icon;
export declare const Restaurant: Icon;
export declare const RestroomMen: Icon;
export declare const RestroomWomen: Icon;
export declare const Restroom: Icon;
export declare const Resume: Icon;
export declare const Return: Icon;
export declare const Revert: Icon;
export declare const Rewind: Icon;
export declare const Risk: Icon;
export declare const Robot: Icon;
export declare const RotateLeft: Icon;
export declare const RotateRight: Icon;
export declare const Rss: Icon;
export declare const Run: Icon;
export declare const SafariOption: Icon;
export declare const Satellite: Icon;
export declare const Save: Icon;
export declare const Scan: Icon;
export declare const ScheduleNew: Icon;
export declare const SchedulePlay: Icon;
export declare const Schedule: Icon;
export declare const Schedules: Icon;
export declare const Sco: Icon;
export declare const Scorecard: Icon;
export declare const SearchAdvanced: Icon;
export declare const Search: Icon;
export declare const Secure: Icon;
export declare const Select: Icon;
export declare const Selection: Icon;
export declare const Semantics: Icon;
export declare const Send: Icon;
export declare const ServerCluster: Icon;
export declare const Server: Icon;
export declare const Servers: Icon;
export declare const ServicePlay: Icon;
export declare const Services: Icon;
export declare const SettingsOption: Icon;
export declare const ShareOption: Icon;
export declare const Share: Icon;
export declare const ShieldSecurity: Icon;
export declare const Shield: Icon;
export declare const Shift: Icon;
export declare const Shop: Icon;
export declare const Sidebar: Icon;
export declare const Sign: Icon;
export declare const Skype: Icon;
export declare const Slack: Icon;
export declare const Snapchat: Icon;
export declare const Solaris: Icon;
export declare const Sort: Icon;
export declare const Soundcloud: Icon;
export declare const Spa: Icon;
export declare const Spectrum: Icon;
export declare const Split: Icon;
export declare const Splits: Icon;
export declare const Spotify: Icon;
export declare const Square: Icon;
export declare const StackOverflow: Icon;
export declare const Stakeholder: Icon;
export declare const StarHalf: Icon;
export declare const Star: Icon;
export declare const StatusCriticalSmall: Icon;
export declare const StatusCritical: Icon;
export declare const StatusDisabledSmall: Icon;
export declare const StatusDisabled: Icon;
export declare const StatusGoodSmall: Icon;
export declare const StatusGood: Icon;
export declare const StatusInfoSmall: Icon;
export declare const StatusInfo: Icon;
export declare const StatusPlaceholderSmall: Icon;
export declare const StatusPlaceholder: Icon;
export declare const StatusUnknownSmall: Icon;
export declare const StatusUnknown: Icon;
export declare const StatusWarningSmall: Icon;
export declare const StatusWarning: Icon;
export declare const StepsOption: Icon;
export declare const Steps: Icon;
export declare const StopFill: Icon;
export declare const Stop: Icon;
export declare const Storage: Icon;
export declare const StreetView: Icon;
export declare const StrikeThrough: Icon;
export declare const Stripe: Icon;
export declare const Subscript: Icon;
export declare const SubtractCircle: Icon;
export declare const Subtract: Icon;
export declare const Superscript: Icon;
export declare const Support: Icon;
export declare const Suse: Icon;
export declare const Swift: Icon;
export declare const Swim: Icon;
export declare const Sync: Icon;
export declare const System: Icon;
export declare const TableAdd: Icon;
export declare const Table: Icon;
export declare const Tag: Icon;
export declare const TapeOption: Icon;
export declare const Tape: Icon;
export declare const Target: Icon;
export declare const Task: Icon;
export declare const Tasks: Icon;
export declare const Technology: Icon;
export declare const Template: Icon;
export declare const Terminal: Icon;
export declare const TestDesktop: Icon;
export declare const Test: Icon;
export declare const TextAlignCenter: Icon;
export declare const TextAlignFull: Icon;
export declare const TextAlignLeft: Icon;
export declare const TextAlignRight: Icon;
export declare const TextWrap: Icon;
export declare const Threats: Icon;
export declare const ThreeDffects: Icon;
export declare const ThreeD: Icon;
export declare const Ticket: Icon;
export declare const Tip: Icon;
export declare const Toast: Icon;
export declare const Tools: Icon;
export declare const Tooltip: Icon;
export declare const TopCorner: Icon;
export declare const Train: Icon;
export declare const Transaction: Icon;
export declare const Trash: Icon;
export declare const TreeOption: Icon;
export declare const Tree: Icon;
export declare const Trigger: Icon;
export declare const Trophy: Icon;
export declare const Troubleshoot: Icon;
export declare const Tty: Icon;
export declare const Tumblr: Icon;
export declare const Turbolinux: Icon;
export declare const Twitter: Icon;
export declare const Ubuntu: Icon;
export declare const Underline: Icon;
export declare const Undo: Icon;
export declare const Unlink: Icon;
export declare const Unlock: Icon;
export declare const UnorderedList: Icon;
export declare const Up: Icon;
export declare const Update: Icon;
export declare const Upgrade: Icon;
export declare const Upload: Icon;
export declare const UserAdd: Icon;
export declare const UserAdmin: Icon;
export declare const UserExpert: Icon;
export declare const UserFemale: Icon;
export declare const UserManager: Icon;
export declare const UserNew: Icon;
export declare const UserPolice: Icon;
export declare const UserSettings: Icon;
export declare const UserWorker: Icon;
export declare const User: Icon;
export declare const Validate: Icon;
export declare const Vend: Icon;
export declare const Video: Icon;
export declare const View: Icon;
export declare const Vimeo: Icon;
export declare const VirtualMachine: Icon;
export declare const VirtualStorage: Icon;
export declare const Visa: Icon;
export declare const VmMaintenance: Icon;
export declare const Vmware: Icon;
export declare const VolumeControl: Icon;
export declare const VolumeLow: Icon;
export declare const VolumeMute: Icon;
export declare const Volume: Icon;
export declare const Vulnerability: Icon;
export declare const Waypoint: Icon;
export declare const WheelchairActive: Icon;
export declare const Wheelchair: Icon;
export declare const WifiLow: Icon;
export declare const WifiMedium: Icon;
export declare const WifiNone: Icon;
export declare const Wifi: Icon;
export declare const WindowsLegacy: Icon;
export declare const Windows: Icon;
export declare const Wordpress: Icon;
export declare const Workshop: Icon;
export declare const Yoga: Icon;
export declare const Youtube: Icon;
export declare const ZoomIn: Icon;
export declare const ZoomOut: Icon;
export declare const Blank: Icon;
