import React from 'react';
import { storiesOf } from '@storybook/react';
import isChromatic from 'chromatic/isChromatic';

import { Grommet, Box, Distribution, Text } from 'grommet';
import { grommet } from 'grommet/themes';

const SimpleDistribution = () => (
  <Grommet theme={grommet} full>
    <Distribution
      fill
      values={[
        { value: 50, color: 'light-3' },
        { value: 30, color: 'neutral-1' },
        { value: 20, color: 'brand' },
        { value: 10, color: 'light-3' },
        { value: 5, color: 'neutral-1' },
      ]}
    >
      {value => (
        <Box pad="xsmall" background={value.color} fill>
          <Text size="large">{value.value}</Text>
        </Box>
      )}
    </Distribution>
  </Grommet>
);

if (!isChromatic()) {
  storiesOf('TypeScript/Distribution', module).add('Simple', () => (
    <SimpleDistribution />
  ));
}
