import { Query, QueryState } from './query';
import { BaseQueryConfig } from './types';
export declare type OnStateUpdateFunction<TResult, TError> = (state: QueryState<TResult, TError>) => void;
export declare class QueryInstance<TResult, TError> {
    id: number;
    config: BaseQueryConfig<TResult, TError>;
    onStateUpdate?: OnStateUpdateFunction<TResult, TError>;
    private query;
    private refetchIntervalId?;
    constructor(query: Query<TResult, TError>, onStateUpdate?: OnStateUpdateFunction<TResult, TError>);
    clearInterval(): void;
    updateConfig(config: BaseQueryConfig<TResult, TError>): void;
    run(): Promise<void>;
    unsubscribe(): void;
}
